Bug 1008532 - Review Request: copr - Cool Other Package Repo
Review Request: copr - Cool Other Package Repo
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Kevin Fenzi
Fedora Extras Quality Assurance
:
Depends On: 1010810 1010811 1010812 1010813 1010814 1010829
Blocks:
  Show dependency treegraph
 
Reported: 2013-09-16 10:37 EDT by Miroslav Suchý
Modified: 2014-01-03 07:39 EST (History)
3 users (show)

See Also:
Fixed In Version: copr-1.8-1.fc19
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2013-10-09 10:47:19 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
kevin: fedora‑review+
limburgher: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description Miroslav Suchý 2013-09-16 10:37:39 EDT
Spec URL: http://miroslav.suchy.cz/fedora/copr/copr.spec
SRPM URL: http://miroslav.suchy.cz/fedora/copr/copr-1.4-1.fc19.src.rpm
Description:
COPR is lightweight build system. It allows you to create new project in WebUI,
and submit new builds and COPR will create yum repository from latest builds.

Fedora Account System Username:
msuchy

Koji Scratch build:
http://koji.fedoraproject.org/koji/taskinfo?taskID=5940583

rpmlint warnings:
/etc/copr/* is non readable because it contains passwords, for that reason it is owned by copr user
/var/log/copr and /var/lib/copr are owned by copr user because copr application (which is run under copr user) need to write there.
Comment 1 Christopher Meng 2013-09-16 10:44:28 EDT
Should BR python-setuptools.

And preserve timestamps when install (-p)

I think it's written in py2k, so %{__python} --> %{__python2}/ %{python_sitelib} --> %{python2_sitelib}

Do not mark %{_mandir}/man1/copr-cli.1* as %doc.
Comment 2 Miroslav Suchý 2013-09-16 11:10:05 EDT
> Should BR python-setuptools.
It is there - at line 25

> And preserve timestamps when install (-p)
fixed

> I think it's written in py2k, so %{__python} --> %{__python2}/ %{python_sitelib} --> %{python2_sitelib}

Guidelines:
http://fedoraproject.org/wiki/Packaging:Python#Macros
say that I should use %{python_sitelib}
ok I changed %{__python} --> %{__python2}, but sitelib should IMO stay.

> Do not mark %{_mandir}/man1/copr-cli.1* as %doc.
fixed.

Updated:
Spec URL: http://miroslav.suchy.cz/fedora/copr/copr.spec
SRPM URL: http://miroslav.suchy.cz/fedora/copr/copr-1.5-1.fc19.src.rpm
Comment 3 Miroslav Suchý 2013-09-18 05:59:33 EDT
oops, 1.5 failed to build

Updated:
Spec URL: http://miroslav.suchy.cz/fedora/copr/copr.spec
SRPM URL: http://miroslav.suchy.cz/fedora/copr/copr-1.6-1.fc19.src.rpm
Comment 4 Kevin Fenzi 2013-09-21 15:13:07 EDT
I'll go ahead and review this. Look for a full review in a bit.
Comment 5 Kevin Fenzi 2013-09-21 16:04:22 EDT
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated

Issues/Questions:
=================
- Package contains BR: python2-devel or python3-devel
- All build dependencies are listed in BuildRequires, except for any that are
  listed in the exceptions section of Packaging Guidelines.
  Note: These BR are not needed: make
  See: http://fedoraproject.org/wiki/Packaging/Guidelines#Exceptions_2
- Do you plan a fedorahosted tar.gz release? Would be nice for checking
  checksums and downloading, etc. 
- There's some directory ownership issues. Perhaps it would be more clear
  to have a base/common package with all the common dirs and license, and 
  require it from the others? 
- The backend needs lighttpd and the frontend httpd? 
- misc other minor stuff marked with !

===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses found:
     "GPL (v2 or later)", "Unknown or generated". 54 files have unknown
     license. Detailed output of licensecheck in /home/fedora/kevin/copr
     /review-copr/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[!]: Package requires other packages for directories it uses.
     Note: No known owner of /usr/share/doc/copr
[!]: Package must own all directories that it creates.
     Note: Directories without known owners:
     /usr/share/selinux/devel/include/apps, /etc/copr, /etc/logrotate.d,
     /usr/share/doc/copr, /usr/share/selinux/devel/include,
     /usr/share/selinux/devel
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[x]: Each %files section contains %defattr if rpm < 4.4
     Note: %defattr present but not needed
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[!]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 102400 bytes in 11 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: %config files are marked noreplace or the reason is justified.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: No %config files under /usr.
[x]: Package do not use a name that already exist
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Python:
[x]: Python eggs must not download any dependencies during the build process.
[x]: A package which is used by another package via an egg interface should
     provide egg info.
[x]: Package meets the Packaging Guidelines::Python
[x]: Binary eggs must be removed in %prep

===== SHOULD items =====

Generic:
[!]: Uses parallel make %{?_smp_mflags} macro.
[x]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Package does not include license text files separate from upstream.
[x]: Scriptlets must be sane, if used.
[!]: SourceX tarball generation or download is documented.
     Note: Package contains tarball without URL, check comments
[x]: Packages should try to preserve timestamps of original installed files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: Dist tag is present (not strictly required in GL).
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package is
     arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: copr-backend-1.6-1.fc21.noarch.rpm
          copr-frontend-1.6-1.fc21.noarch.rpm
          copr-cli-1.6-1.fc21.noarch.rpm
          copr-doc-1.6-1.fc21.noarch.rpm
          copr-selinux-1.6-1.fc21.noarch.rpm
          copr-1.6-1.fc21.src.rpm
copr-backend.noarch: W: non-standard-uid /var/log/copr/workers copr
copr-backend.noarch: W: non-standard-gid /var/log/copr/workers copr
copr-backend.noarch: W: non-standard-uid /var/log/copr copr
copr-backend.noarch: W: non-standard-gid /var/log/copr copr
copr-backend.noarch: W: non-standard-uid /var/lib/copr/public_html/results copr
copr-backend.noarch: W: non-standard-gid /var/lib/copr/public_html/results copr
copr-backend.noarch: W: non-standard-uid /var/lib/copr/public_html copr
copr-backend.noarch: W: non-standard-gid /var/lib/copr/public_html copr
copr-frontend.noarch: W: spelling-error %description -l en_US latests -> latest, latest's, la tests
copr-frontend.noarch: W: non-standard-uid /etc/copr/copr_unit_test.conf copr-fe
copr-frontend.noarch: W: non-standard-gid /etc/copr/copr_unit_test.conf copr-fe
copr-frontend.noarch: E: non-readable /etc/copr/copr_unit_test.conf 0600L
copr-frontend.noarch: W: non-standard-uid /etc/copr copr-fe
copr-frontend.noarch: W: non-standard-gid /etc/copr copr-fe
copr-frontend.noarch: E: non-standard-dir-perm /etc/copr 0700L
copr-frontend.noarch: W: non-standard-uid /var/lib/copr/data/whooshee/copr_user_whoosheer copr-fe
copr-frontend.noarch: W: non-standard-gid /var/lib/copr/data/whooshee/copr_user_whoosheer copr-fe
copr-frontend.noarch: W: non-standard-uid /var/lib/copr/data/copr.db copr-fe
copr-frontend.noarch: W: non-standard-gid /var/lib/copr/data/copr.db copr-fe
copr-frontend.noarch: W: non-standard-uid /var/lib/copr/data copr-fe
copr-frontend.noarch: W: non-standard-gid /var/lib/copr/data copr-fe
copr-frontend.noarch: W: non-standard-uid /etc/copr/copr_devel.conf copr-fe
copr-frontend.noarch: W: non-standard-gid /etc/copr/copr_devel.conf copr-fe
copr-frontend.noarch: E: non-readable /etc/copr/copr_devel.conf 0600L
copr-frontend.noarch: W: non-standard-uid /var/lib/copr/data/openid_store copr-fe
copr-frontend.noarch: W: non-standard-gid /var/lib/copr/data/openid_store copr-fe
copr-frontend.noarch: W: non-standard-uid /etc/copr/copr.conf copr-fe
copr-frontend.noarch: W: non-standard-gid /etc/copr/copr.conf copr-fe
copr-frontend.noarch: E: non-readable /etc/copr/copr.conf 0600L
copr-frontend.noarch: W: non-standard-uid /var/lib/copr/data/whooshee copr-fe
copr-frontend.noarch: W: non-standard-gid /var/lib/copr/data/whooshee copr-fe
copr-cli.noarch: W: spelling-error %description -l en_US latests -> latest, latest's, la tests
copr-doc.noarch: W: spelling-error %description -l en_US latests -> latest, latest's, la tests
copr-selinux.noarch: E: explicit-lib-dependency libselinux-utils
copr-selinux.noarch: W: spelling-error %description -l en_US latests -> latest, latest's, la tests
copr.src: W: unexpanded-macro dependency policycoreutils >= %{POLICYCOREUTILSVER} %{POLICYCOREUTILSVER}
copr.src:19: W: macro-in-comment %{name}
copr.src:19: W: macro-in-comment %{version}
copr.src:218: W: macro-in-comment %posttrans
copr.src:38: W: mixed-use-of-spaces-and-tabs (spaces: line 38, tab: line 7)
copr.src: W: invalid-url Source0: copr-1.6.tar.gz
6 packages and 0 specfiles checked; 5 errors, 36 warnings.




Rpmlint (installed packages)
----------------------------
# rpmlint copr-frontend copr-selinux copr-doc copr-cli copr-backend
copr-frontend.noarch: W: spelling-error %description -l en_US latests -> latest, latest's, la tests
copr-frontend.noarch: W: non-standard-uid /etc/copr/copr_unit_test.conf copr-fe
copr-frontend.noarch: W: non-standard-gid /etc/copr/copr_unit_test.conf copr-fe
copr-frontend.noarch: E: non-readable /etc/copr/copr_unit_test.conf 0600L
copr-frontend.noarch: W: non-standard-uid /etc/copr copr-fe
copr-frontend.noarch: W: non-standard-gid /etc/copr copr-fe
copr-frontend.noarch: E: non-standard-dir-perm /etc/copr 0700L
copr-frontend.noarch: W: non-standard-uid /var/lib/copr/data/whooshee/copr_user_whoosheer copr-fe
copr-frontend.noarch: W: non-standard-gid /var/lib/copr/data/whooshee/copr_user_whoosheer copr-fe
copr-frontend.noarch: W: non-standard-uid /var/lib/copr/data/copr.db copr-fe
copr-frontend.noarch: W: non-standard-gid /var/lib/copr/data/copr.db copr-fe
copr-frontend.noarch: W: non-standard-uid /var/lib/copr/data copr-fe
copr-frontend.noarch: W: non-standard-gid /var/lib/copr/data copr-fe
copr-frontend.noarch: W: non-standard-uid /etc/copr/copr_devel.conf copr-fe
copr-frontend.noarch: W: non-standard-gid /etc/copr/copr_devel.conf copr-fe
copr-frontend.noarch: E: non-readable /etc/copr/copr_devel.conf 0600L
copr-frontend.noarch: W: non-standard-uid /var/lib/copr/data/openid_store copr-fe
copr-frontend.noarch: W: non-standard-gid /var/lib/copr/data/openid_store copr-fe
copr-frontend.noarch: W: non-standard-uid /etc/copr/copr.conf copr-fe
copr-frontend.noarch: W: non-standard-gid /etc/copr/copr.conf copr-fe
copr-frontend.noarch: E: non-readable /etc/copr/copr.conf 0600L
copr-frontend.noarch: W: non-standard-uid /var/lib/copr/data/whooshee copr-fe
copr-frontend.noarch: W: non-standard-gid /var/lib/copr/data/whooshee copr-fe
copr-selinux.noarch: E: explicit-lib-dependency libselinux-utils
copr-selinux.noarch: W: spelling-error %description -l en_US latests -> latest, latest's, la tests
copr-doc.noarch: W: spelling-error %description -l en_US latests -> latest, latest's, la tests
copr-cli.noarch: W: spelling-error %description -l en_US latests -> latest, latest's, la tests
copr-backend.noarch: W: non-standard-uid /var/log/copr/workers copr
copr-backend.noarch: W: non-standard-gid /var/log/copr/workers copr
copr-backend.noarch: W: non-standard-uid /var/log/copr copr
copr-backend.noarch: W: non-standard-gid /var/log/copr copr
copr-backend.noarch: W: non-standard-uid /var/lib/copr/public_html/results copr
copr-backend.noarch: W: non-standard-gid /var/lib/copr/public_html/results copr
copr-backend.noarch: W: non-standard-uid /var/lib/copr/public_html copr
copr-backend.noarch: W: non-standard-gid /var/lib/copr/public_html copr
5 packages and 0 specfiles checked; 5 errors, 30 warnings.
# echo 'rpmlint-done:'



Requires
--------
copr-frontend (rpmlib, GLIBC filtered):
    /bin/sh
    /usr/bin/env
    /usr/bin/python
    config(copr-frontend)
    httpd
    mod_wsgi
    pytest
    python-alembic
    python-blinker
    python-flask
    python-flask-openid
    python-flask-script
    python-flask-sqlalchemy
    python-flask-whooshee
    python-flask-wtf
    python-flexmock
    python-psycopg2
    python-pylibravatar
    python-whoosh

copr-selinux (rpmlib, GLIBC filtered):
    /bin/bash
    /bin/sh
    libselinux-utils
    policycoreutils
    policycoreutils-python
    selinux-policy-targeted

copr-doc (rpmlib, GLIBC filtered):

copr-cli (rpmlib, GLIBC filtered):
    /usr/bin/python2
    python(abi)
    python-requests

copr-backend (rpmlib, GLIBC filtered):
    /bin/sh
    /usr/bin/python
    ansible
    config(copr-backend)
    createrepo
    euca2ools
    lighttpd
    mock
    openssh-clients
    python-bunch
    python-requests
    rsync
    yum-utils



Provides
--------
copr-frontend:
    config(copr-frontend)
    copr-frontend

copr-selinux:
    copr-selinux

copr-doc:
    copr-doc

copr-cli:
    copr-cli

copr-backend:
    config(copr-backend)
    copr-backend



Generated by fedora-review 0.5.0 (920221d) last change: 2013-08-30
Command line :/usr/bin/fedora-review -n copr
Buildroot used: fedora-rawhide-vanilla-x86_64
Active plugins: Python, Generic, Shell-api
Disabled plugins: Java, C/C++, SugarActivity, Perl, R, PHP, Ruby
Disabled flags: EPEL5, EXARCH, DISTTAG
Comment 6 Miroslav Suchý 2013-09-23 02:04:56 EDT
> Package contains BR: python2-devel or python3-devel

Last time I checked it, not all copr dependencies were available under python3.
I will check it again.

> - All build dependencies are listed in BuildRequires, except for any that are
>  listed in the exceptions section of Packaging Guidelines.
>  Note: These BR are not needed: make
>  See: http://fedoraproject.org/wiki/Packaging/Guidelines#Exceptions_2

make is used in %build section. Hmm but it lacks of smp_macro - added.

> - Do you plan a fedorahosted tar.gz release? Would be nice for checking
>  checksums and downloading, etc. 

Not in near feature. Maybe later when development stabilize little bit more.

> - There's some directory ownership issues. Perhaps it would be more clear
>  to have a base/common package with all the common dirs and license, and 
>  require it from the others? 

I see. I will fix that.

> The backend needs lighttpd and the frontend httpd? 

Yes. Frontend execute those Flask script and provide UI. This can be hardly done with lighttpd and apache is best choice.
While backend provide yum repositories (BTW) and no CGI scripts are executed there. So lighttpd is best choice.

> - misc other minor stuff marked with !
Will fix that.
Comment 7 Miroslav Suchý 2013-09-23 02:14:05 EDT
> Package contains BR: python2-devel or python3-devel

I do confirm - at least python-flask is not available for python3 in Fedora 19. It is available in Fedora 20. But this package must run under Fedora 19. So for me it is blocker.

I will create BZs for those deps which does not have python3 package not even in rawhide. But for now Copr have to stay on python2 :(
Comment 8 Miroslav Suchý 2013-09-23 03:06:15 EDT
Filed bugs: 1010810, 1010811, 1010812, 1010813, 1010814 and 1010829 for missing python3 dependencies. Until they are resolved Copr is staying as python2 only.
Comment 10 Kevin Fenzi 2013-09-23 11:27:14 EDT
I didn't mean to make python3 any kind of requirement. I simply meant that if this was python2, it should "BuildRequires: python2-devel" per the guidelines. (instead of just 'python-devel). 

While python3 would be nice, it's by no means a blocker, IMHO. 

I'll look at the other changes later today. Thanks.
Comment 11 Miroslav Suchý 2013-09-24 09:15:22 EDT
> I simply meant that if this was python2, it should "BuildRequires: python2-devel" per the guidelines. (instead of just 'python-devel). 

Aha. Misunderstood. Fixed:

Updated:
Spec URL: http://miroslav.suchy.cz/fedora/copr/copr.spec
SRPM URL: http://miroslav.suchy.cz/fedora/copr/copr-1.8-1.fc19.src.rpm
Comment 12 Kevin Fenzi 2013-09-25 18:31:20 EDT
Well, 'make' is in the default minimal buildroot, so it's not needed... 
"There is no need to include the following packages or their dependencies as BuildRequires because they would occur too often". 

Otherwise everything looks good. APPROVED.
Comment 13 Miroslav Suchý 2013-09-26 04:20:42 EDT
New Package SCM Request
=======================
Package Name: copr
Short Description: Cool Other Package Repo
Owners: msuchy
Branches: f19 f20
InitialCC:
Comment 14 Kevin Fenzi 2013-09-27 14:42:06 EDT
Git done (by process-git-requests).
Comment 15 Fedora Update System 2013-09-30 00:08:23 EDT
copr-1.8-1.fc19 has been submitted as an update for Fedora 19.
https://admin.fedoraproject.org/updates/copr-1.8-1.fc19
Comment 16 Fedora Update System 2013-09-30 00:09:11 EDT
copr-1.8-1.fc20 has been submitted as an update for Fedora 20.
https://admin.fedoraproject.org/updates/copr-1.8-1.fc20
Comment 17 Fedora Update System 2013-09-30 21:55:47 EDT
copr-1.8-1.fc20 has been pushed to the Fedora 20 testing repository.
Comment 18 Fedora Update System 2013-10-09 10:47:19 EDT
copr-1.8-1.fc20 has been pushed to the Fedora 20 stable repository.
Comment 19 Fedora Update System 2013-10-09 20:53:45 EDT
copr-1.8-1.fc19 has been pushed to the Fedora 19 stable repository.
Comment 20 Miroslav Suchý 2014-01-03 06:41:51 EST
Package Change Request
======================
Package Name: copr
New Branches: el5 el6
Owners: msuchy
Comment 21 Gwyn Ciesla 2014-01-03 07:39:29 EST
Git done (by process-git-requests).

Note You need to log in before you can comment on or make changes to this bug.